#! /usr/bin/env python

#
#	The banks server
#

import sys, socket
import Pyro.naming
import Pyro.core
from Pyro.errors import PyroError,NamingError
import banks

group = ':banks'   # the namespace group for all test servers

# avoid network port trouble with the VSB bank server
Pyro.config.PYRO_PORT=Pyro.config.PYRO_PORT+1

# initialize the server and set the default namespace group
Pyro.core.initServer()
Pyro.config.PYRO_NS_DEFAULTGROUP=group


# locate the NS
print 'Searching Naming Service...'
PyroDaemon = Pyro.core.Daemon()
locator = Pyro.naming.NameServerLocator()
try:
	ns = locator.getNS()
except (PyroError,socket.error),x:
	hn = socket.gethostname()
	print '\nNaming Service not found with broadcast. Trying host',hn,'...',
	ns = locator.getNS(host=hn)


# make sure our namespace group exists
try:
	ns.createGroup(group)
except NamingError:
	pass

PyroDaemon.useNameServer(ns)

# connect a new object implementation (first unregister previous one)
try:
	ns.unregister('Rabobank')
	ns.unregister('VSB')
except NamingError:
	pass

# use Delegation approach for object implementation
obj1=Pyro.core.ObjBase()
obj1.delegateTo(banks.Rabobank())
PyroDaemon.connect(obj1,'Rabobank')
obj2=Pyro.core.ObjBase()
obj2.delegateTo(banks.VSB())
PyroDaemon.connect(obj2,'VSB')

# enter the service loop.
print 'Banks are ready for customers.'
while 1:
	PyroDaemon.handleRequests(3.0)
	print '.',
	sys.stdout.flush()

